import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Directive, Input, Output } from '@angular/core';

const allColors = {
    /* colorsDefault */
    primary: "#0d6efd",
    secondary: "#6c757d",
    success: "#198754",
    info: "#0dcaf0",
    warning: "#ffc107",
    danger: "#dc3545",
    light: "#f8f9fa",
    dark: "#212529",
    /* colorsBS */
    indigoBS: "#6610f2",
    purpleBS: "#6f42c1",
    pinkBS: "#d63384",
    orangeBS: "#fd7e14",
    tealBS: "#20c997",
    white: "#fff",
    grayBS: "#6c757d",
    /* colorsLP */
    mystic: "#210020",
    lavenderLP: "#D6BCFF",
    fairy: "#D680FF",
    summer: "#FF9A2E",
    old: "#EEEDA0",
    friend: "#3BBBB2",
    tree: "#5A311D",
    blood: "#8A0707",
    beast: "#F5785D",
    abyss: "#000",
    /* basicColorsCSS */ /* (\s)(#[0-9A-Fa-f]+)\s([0-9]*,?)*\n*\s*\n*\s* */ /* :$1'$2', */
    black: "#000000",
    silver: "#C0C0C0",
    gray: "#808080",
    maroon: "#800000",
    red: "#FF0000",
    purple: "#800080",
    fuchsia: "#FF00FF",
    green: "#008000",
    lime: "#00FF00",
    olive: "#808000",
    yellow: "#FFFF00",
    navy: "#000080",
    blue: "#0000FF",
    teal: "#008080",
    aqua: "#00FFFF",
    /* extendedColorsCSS */
    aliceblue: "#f0f8ff",
    antiquewhite: "#faebd7",
    aquamarine: "#7fffd4",
    azure: "#f0ffff",
    beige: "#f5f5dc",
    bisque: "#ffe4c4",
    blanchedalmond: "#ffebcd",
    blueviolet: "#8a2be2",
    brown: "#a52a2a",
    burlywood: "#deb887",
    cadetblue: "#5f9ea0",
    chartreuse: "#7fff00",
    chocolate: "#d2691e",
    coral: "#ff7f50",
    cornflowerblue: "#6495ed",
    cornsilk: "#fff8dc",
    crimson: "#dc143c",
    cyan: "#00ffff",
    darkblue: "#00008b",
    darkcyan: "#008b8b",
    darkgoldenrod: "#b8860b",
    darkgray: "#a9a9a9",
    darkgreen: "#006400",
    darkgrey: "#a9a9a9",
    darkkhaki: "#bdb76b",
    darkmagenta: "#8b008b",
    darkolivegreen: "#556b2f",
    darkorange: "#ff8c00",
    darkorchid: "#9932cc",
    darkred: "#8b0000",
    darksalmon: "#e9967a",
    darkseagreen: "#8fbc8f",
    darkslateblue: "#483d8b",
    darkslategray: "#2f4f4f",
    darkslategrey: "#2f4f4f",
    darkturquoise: "#00ced1",
    darkviolet: "#9400d3",
    deeppink: "#ff1493",
    deepskyblue: "#00bfff",
    dimgray: "#696969",
    dimgrey: "#696969",
    dodgerblue: "#1e90ff",
    firebrick: "#b22222",
    floralwhite: "#fffaf0",
    forestgreen: "#228b22",
    gainsboro: "#dcdcdc",
    ghostwhite: "#f8f8ff",
    gold: "#ffd700",
    goldenrod: "#daa520",
    greenyellow: "#adff2f",
    grey: "#808080",
    honeydew: "#f0fff0",
    hotpink: "#ff69b4",
    indianred: "#cd5c5c",
    indigo: "#4b0082",
    ivory: "#fffff0",
    khaki: "#f0e68c",
    lavender: "#e6e6fa",
    lavenderblush: "#fff0f5",
    lawngreen: "#7cfc00",
    lemonchiffon: "#fffacd",
    lightblue: "#add8e6",
    lightcoral: "#f08080",
    lightcyan: "#e0ffff",
    lightgoldenrodyellow: "#fafad2",
    lightgray: "#d3d3d3",
    lightgreen: "#90ee90",
    lightgrey: "#d3d3d3",
    lightpink: "#ffb6c1",
    lightsalmon: "#ffa07a",
    lightseagreen: "#20b2aa",
    lightskyblue: "#87cefa",
    lightslategray: "#778899",
    lightslategrey: "#778899",
    lightsteelblue: "#b0c4de",
    lightyellow: "#ffffe0",
    limegreen: "#32cd32",
    linen: "#faf0e6",
    magenta: "#ff00ff",
    mediumaquamarine: "#66cdaa",
    mediumblue: "#0000cd",
    mediumorchid: "#ba55d3",
    mediumpurple: "#9370db",
    mediumseagreen: "#3cb371",
    mediumslateblue: "#7b68ee",
    mediumspringgreen: "#00fa9a",
    mediumturquoise: "#48d1cc",
    mediumvioletred: "#c71585",
    midnightblue: "#191970",
    mintcream: "#f5fffa",
    mistyrose: "#ffe4e1",
    moccasin: "#ffe4b5",
    navajowhite: "#ffdead",
    oldlace: "#fdf5e6",
    olivedrab: "#6b8e23",
    orange: "#ffa500",
    orangered: "#ff4500",
    orchid: "#da70d6",
    palegoldenrod: "#eee8aa",
    palegreen: "#98fb98",
    paleturquoise: "#afeeee",
    palevioletred: "#db7093",
    papayawhip: "#ffefd5",
    peachpuff: "#ffdab9",
    peru: "#cd853f",
    pink: "#ffc0cb",
    plum: "#dda0dd",
    powderblue: "#b0e0e6",
    rosybrown: "#bc8f8f",
    royalblue: "#4169e1",
    saddlebrown: "#8b4513",
    salmon: "#fa8072",
    sandybrown: "#f4a460",
    seagreen: "#2e8b57",
    seashell: "#fff5ee",
    sienna: "#a0522d",
    skyblue: "#87ceeb",
    slateblue: "#6a5acd",
    slategray: "#708090",
    slategrey: "#708090",
    snow: "#fffafa",
    springgreen: "#00ff7f",
    steelblue: "#4682b4",
    tan: "#d2b48c",
    thistle: "#d8bfd8",
    tomato: "#ff6347",
    turquoise: "#40e0d0",
    violet: "#ee82ee",
    wheat: "#f5deb3",
    whitesmoke: "#f5f5f5",
    yellowgreen: "#9acd32",
};

const cssNamesParsed = {
    d: "display",
    ta: "text-align",
    w: "width",
    h: "height",
    wmn: "min-width",
    hmn: "min-height",
    wmx: "max-width",
    hmx: "max-height",
    minw: "min-width",
    minh: "min-height",
    maxw: "max-width",
    maxh: "max-height",
    rounded: "border-radius",
    r: "border-radius",
    rs: ["border-top-left-radius", "border-bottom-left-radius"],
    re: ["border-top-right-radius", "border-bottom-right-radius"],
    rt: ["border-top-left-radius", "border-top-right-radius"],
    rb: ["border-bottom-left-radius", "border-bottom-right-radius"],
    rst: "border-top-left-radius",
    ret: "border-top-right-radius",
    rsb: "border-bottom-left-radius",
    reb: "border-bottom-right-radius",
    z: "z-index",
    o: "opacity",
    pos: "position",
    t: "top",
    bot: "bottom",
    b: "bottom",
    start: "left",
    s: "left",
    end: "right",
    e: "right",
    fs: "font-size",
    lh: "line-height",
    g: "gap",
    p: "padding",
    pt: "padding-top",
    pb: "padding-bottom",
    ps: "padding-left",
    pe: "padding-right",
    py: ["padding-top", "padding-bottom"],
    px: ["padding-left", "padding-right"],
    m: "margin",
    mt: "margin-top",
    mb: "margin-bottom",
    ms: "margin-left",
    me: "margin-right",
    my: ["margin-top", "margin-bottom"],
    mx: ["margin-left", "margin-right"],
    bw: "border-width",
    bwt: "border-top-width",
    bwb: "border-bottom-width",
    bws: "border-left-width",
    bwe: "border-right-width",
    bwy: ["border-top-width", "border-bottom-width"],
    bwx: ["border-left-width", "border-right-width"],
    borderStylet: "border-top-style",
    borderStyleb: "border-bottom-style",
    borderStyles: "border-left-style",
    borderStylee: "border-right-style",
    borderStyley: ["border-top-style", "border-bottom-style"],
    borderStylex: ["border-left-style", "border-right-style"],
    bs: "border-style",
    bst: "border-top-style",
    bsb: "border-bottom-style",
    bss: "border-left-style",
    bse: "border-right-style",
    bsy: ["border-top-style", "border-bottom-style"],
    bsx: ["border-left-style", "border-right-style"],
    borderColort: "border-top-color",
    borderColorb: "border-bottom-color",
    borderColors: "border-left-color",
    borderColore: "border-right-color",
    borderColory: ["border-top-color", "border-bottom-color"],
    borderColorx: ["border-left-color", "border-right-color"],
    bc: "border-color",
    bct: "border-top-color",
    bcb: "border-bottom-color",
    bcs: "border-left-color",
    bce: "border-right-color",
    bcy: ["border-top-color", "border-bottom-color"],
    bcx: ["border-left-color", "border-right-color"],
    bg: "background-color",
    text: "color",
    bsh: "box-shadow",
    tsh: "text-shadow",
    ov: "overflow",
    ovx: "overflow-x",
    ovy: "overflow-y",
};

const css_camel = {
    cssValidToCamel(st) {
        return st.replace(/([-_][a-z])/gi, ($1) => {
            return $1.toUpperCase().replace("-", "").replace("_", "");
        });
    },
    camelToCSSValid(st) {
        return st
            .replace(/[\w]([A-Z])/g, (m) => {
            return m[0] + "-" + m[1];
        })
            .toLowerCase();
    },
};

/* Colors */
class ValuesSingleton {
    constructor() {
        this.colors = allColors;
        this.abreviationsClasses = {};
        this.abreviationsValues = {};
        this.combos = {};
        this.combosCreated = {};
        this.cssNamesParsed = cssNamesParsed;
        this.alreadyCreatedClasses = [];
        this.isDebug = false;
        this.bps = [
            {
                bp: "sm",
                value: "576px",
                bef: "",
            },
            {
                bp: "md",
                value: "768px",
                bef: "",
            },
            {
                bp: "lg",
                value: "992px",
                bef: "",
            },
            {
                bp: "xl",
                value: "1200px",
                bef: "",
            },
            {
                bp: "xxl",
                value: "1400px",
                bef: "",
            },
        ];
        this.separator = "þµÞ";
        /* Console */
        this.styleConsole = `padding: 0.25rem 0.125rem; background-color: ${this.colors["mystic"]}; color: ${this.colors["friend"]};`;
        /* Pseudos */
        this.pseudoClasses = [
            "Active",
            "AnyLink",
            "Autofill",
            "Blank",
            "Checked",
            "Current",
            "Default",
            "Defined",
            "Dir",
            "Disabled",
            "Empty",
            "Enabled",
            "First",
            "FirstChild",
            "FirstOfType",
            "Focus",
            "FocusVisible",
            "FocusWithin",
            "Fullscreen",
            "Future",
            "Has",
            "Host",
            "Hover",
            "InRange",
            "Indeterminate",
            "Invalid",
            "Is",
            "Lang",
            "LastChild",
            "LastOfType",
            "Left",
            "Link",
            "LocalLink",
            "Modal",
            "Muted",
            "Not",
            "NthChild",
            "NthLastChild",
            "NthLastOfType",
            "NthOfType",
            "OnlyChild",
            "OnlyOfType",
            "Optional",
            "OutOfRange",
            "Past",
            "Paused",
            "PictureInPicture",
            "PlaceHolderShown",
            "Playing",
            "PopoverOpen",
            "ReadOnly",
            "ReadWrite",
            "Required",
            "Right",
            "Root",
            "Scope",
            "Seeking",
            "Stalled",
            "Target",
            "TargetWithin",
            "UserInvalid",
            "UserValid",
            "Valid",
            "Visited",
            "VolumeLocked",
            "Where",
        ];
        this.pseudosHasSDED = [
            "Dir",
            "Not",
            "Lang",
            "Has",
            "Host",
            "Is",
            "NthChild",
            "NthLastChild",
            "NthLastOfType",
            "NthOfType",
            "Part",
            "Slotted",
            "Where",
        ];
        this.pseudoElements = [
            "After",
            "Backdrop",
            "Before",
            "Cue",
            "CueRegion",
            "FileSelectorButton",
            "FirstLetter",
            "FirstLine",
            "GrammarError",
            "Highlight",
            "Marker",
            "Part",
            "Placeholder",
            "Selection",
            "Slotted",
            "SpellingError",
            "TargetText",
            "ViewTransition",
            "ViewTransitionGroup",
            "ViewTransitionImagePair",
            "ViewTransitionNew",
            "ViewTransitionOld",
        ];
        this.pseudos = this.pseudoClasses
            .sort((e1, e2) => {
            e1 = e1.toString().length;
            e2 = e2.toString().length;
            return e1 > e2 ? 1 : e1 < e2 ? -1 : 0;
        })
            .map((pse) => {
            return {
                mask: pse,
                real: `${this.separator}:${css_camel.camelToCSSValid(pse)}`,
            };
        })
            .concat(this.pseudoElements
            .sort((e1, e2) => {
            e1 = e1.toString().length;
            e2 = e2.toString().length;
            return e1 > e2 ? 1 : e1 < e2 ? -1 : 0;
        })
            .map((pse) => {
            return {
                mask: pse,
                real: `${this.separator}::${css_camel.camelToCSSValid(pse)}`,
            };
        }));
        this.importantActive = true;
        this.abreviationTraductors = [
            {
                abreviation: "per",
                traduction: "$1%",
                abreviationRegExp: /(\d+)\s*per/g,
                traductionRegExp: /%/g,
            },
            {
                abreviation: "COM",
                traduction: " , ",
                abreviationRegExp: /COM/g,
                traductionRegExp: /\s*,\s*/g,
            },
            {
                abreviation: "CSP",
                traduction: `'`,
                abreviationRegExp: /CSP/g,
                traductionRegExp: /'/g,
            },
            {
                abreviation: "CDB",
                traduction: `"`,
                abreviationRegExp: /CDB/g,
                traductionRegExp: /"/g,
            },
            {
                abreviation: "MIN",
                traduction: "-",
                abreviationRegExp: /MIN/g,
                traductionRegExp: /-/g,
            },
            {
                abreviation: "PLUS",
                traduction: "+",
                abreviationRegExp: /PLUS/g,
                traductionRegExp: /\+/g,
            },
            {
                abreviation: "SD",
                traduction: "(",
                abreviationRegExp: /SD/g,
                traductionRegExp: /\(/g,
            },
            {
                abreviation: "ED",
                traduction: ")",
                abreviationRegExp: /ED/g,
                traductionRegExp: /\)/g,
            },
            {
                abreviation: "SE",
                traduction: "[",
                abreviationRegExp: /SE/g,
                traductionRegExp: /\[/g,
            },
            {
                abreviation: "EE",
                traduction: "]",
                abreviationRegExp: /EE/g,
                traductionRegExp: /\]/g,
            },
            {
                abreviation: "HASH",
                traduction: "#",
                abreviationRegExp: /HASH/g,
                traductionRegExp: /#/g,
            },
            {
                abreviation: "SLASH",
                traduction: "/",
                abreviationRegExp: /SLASH/g,
                traductionRegExp: /\//g,
            },
            {
                abreviation: "UND",
                traduction: "_",
                abreviationRegExp: /UND/g,
                traductionRegExp: /_/g,
            },
            {
                abreviation: "__",
                traduction: " ",
                abreviationRegExp: /__/g,
                traductionRegExp: /\s+/g,
            },
            {
                abreviation: "_",
                traduction: ".",
                abreviationRegExp: /_/g,
                traductionRegExp: /\./g,
            },
            {
                abreviation: "CHILD",
                traduction: " > ",
                abreviationRegExp: /CHILD/g,
                traductionRegExp: /\s*>\s*/g,
            },
            {
                abreviation: "ADJ",
                traduction: " + ",
                abreviationRegExp: /ADJ/g,
                traductionRegExp: /\s*\+\s*/g,
            },
            {
                abreviation: "SIBL",
                traduction: " ~ ",
                abreviationRegExp: /SIBL/g,
                traductionRegExp: /\s*~\s*/g,
            },
            {
                abreviation: "ALL",
                traduction: "*",
                abreviationRegExp: /ALL/g,
                traductionRegExp: /\*/g,
            },
            {
                abreviation: "EQ",
                traduction: "=",
                abreviationRegExp: /EQ/g,
                traductionRegExp: /=/g,
            },
            {
                abreviation: "ST",
                traduction: "^",
                abreviationRegExp: /ST/g,
                traductionRegExp: /\^/g,
            },
            {
                abreviation: "INC",
                traduction: "$",
                abreviationRegExp: /INC/g,
                traductionRegExp: /\$/g,
            },
            {
                abreviation: "DPS",
                traduction: ":",
                abreviationRegExp: /DPS/g,
                traductionRegExp: /:/g,
            },
            {
                abreviation: "PNC",
                traduction: ";",
                abreviationRegExp: /PNC/g,
                traductionRegExp: /;/g,
            },
        ];
        /* Time Management*/
        this.lastCSSCreate = Date.now();
        this.lastTimeAsked2Create = new Date().getTime();
        this.timesCSSCreated = 0;
        this.timeBetweenReCreate = 400;
        this.useTimer = true;
    }
    static getInstance() {
        if (!ValuesSingleton.instance) {
            ValuesSingleton.instance = new ValuesSingleton();
        }
        return ValuesSingleton.instance;
    }
}

function getStackTrace() {
    let stack;
    try {
        throw new Error("");
    }
    catch (error) {
        stack = error.stack || "";
    }
    stack = stack.split("\n").map((line) => {
        return line.trim();
    });
    return stack.splice(stack[0] == "Error" ? 2 : 1);
}
const values$g = ValuesSingleton.getInstance();
const console_log = {
    consoleLog(type = "log", thing, style = values$g.styleConsole, line = null, stoper = !values$g.isDebug) {
        this.consoleParser({
            type: type,
            thing: thing,
            style: style,
            line: line,
            stoper: stoper,
        });
    },
    consoleParser(config) {
        config.type = config.type ? config.type : "log";
        config.style = config.style ? config.style : values$g.styleConsole;
        config.stoper =
            config.stoper !== undefined ? config.stoper : !values$g.isDebug;
        if (config.stoper === false || config.type === "error") {
            if (config.line) {
                console.info("%cline: " + config.line + " = ", config.style);
            }
            console.info("%c" + getStackTrace()[2], config.style);
            console.groupCollapsed("Trace");
            console.trace();
            console.groupEnd();
            {
                switch (config.type) {
                    case "log":
                        console.log("%c" +
                            (typeof config.thing === "object"
                                ? JSON.stringify(config.thing)
                                : config.thing), config.style);
                        break;
                    case "info":
                        console.info("%c" +
                            (typeof config.thing === "object"
                                ? JSON.stringify(config.thing)
                                : config.thing), config.style);
                        break;
                    case "error":
                        console.error("%c" +
                            (typeof config.thing === "object"
                                ? JSON.stringify(config.thing)
                                : config.thing), config.style);
                        break;
                    default:
                        break;
                }
            }
            if (typeof config.thing === "object") {
                console.dir(config.thing);
            }
        }
    },
};

/* Singletons */
const values$f = ValuesSingleton.getInstance();
const abrevviation_traductors = {
    abreviationTraductor(value, type = "traduce") {
        if (value !== undefined) {
            console_log.consoleLog("info", {
                value_beforeAbreviationTraductor: value,
            });
            for (const abr of values$f.abreviationTraductors) {
                let traduction = abr.traduction;
                let abreviation = abr.abreviation;
                let traductionRegExp = abr.traductionRegExp;
                let abreviationRegExp = abr.abreviationRegExp;
                if (type === "traduce") {
                    value = value.replace(abreviationRegExp, traduction);
                }
                else if (type === "convert") {
                    value = value.replace(traductionRegExp, abreviation);
                }
            }
            console_log.consoleLog("info", {
                value_afterAbreviationTraductor: value,
            });
        }
        return value;
    },
    unbefysize(value) {
        return this.abreviationTraductor(value);
    },
    befysize(value) {
        return this.abreviationTraductor(value, "convert");
    },
};

/* Singletons */
const values$e = ValuesSingleton.getInstance();
const color_transform = {
    colorToRGB(color) {
        try {
            let rgb = [255, 0, 0];
            color = color.toLowerCase();
            switch (true) {
                case !!values$e.colors[color]:
                    rgb = this.colorToRGB(values$e.colors[color]);
                    break;
                case color.includes("rgb") || color.includes("rgba"):
                    rgb = this.parseRGB(color);
                    break;
                case color.includes("#"):
                    rgb = this.parseRGB(this.HexToRGB(color));
                    break;
                case color.includes("hsl"):
                    rgb = this.parseRGB(this.HSLToRGB(color));
                    break;
                case color.includes("hwb"):
                    rgb = this.parseRGB(this.HWBToRGB(color));
                    break;
                default:
                    break;
            }
            return rgb;
        }
        catch (error) {
            console_log.consoleLog("error", { error: error }, values$e.styleConsole);
            return [255, 0, 0];
        }
    },
    RGBToRGBA(rgb, alpha) {
        return `rgba(${rgb[0]},${rgb[1]},${rgb[2]},${alpha})`;
    },
    parseRGB(rgba) {
        let rgb = [];
        if (rgba.includes("rgb") || rgba.includes("rgba")) {
            rgb = rgba.split("(")[1].split(",")[4]
                ? [
                    parseInt(rgba.split("(")[1].split(",")[0]),
                    parseInt(rgba.split("(")[1].split(",")[1]),
                    parseInt(rgba.split("(")[1].split(",")[2]),
                    parseInt(rgba.split("(")[1].split(",")[3]),
                ]
                : [
                    parseInt(rgba.split("(")[1].split(",")[0]),
                    parseInt(rgba.split("(")[1].split(",")[1]),
                    parseInt(rgba.split("(")[1].split(",")[2]),
                ];
        }
        return rgb;
    },
    HexToRGB(Hex) {
        let rgb = [];
        const hexCode = Hex.replace("#", "");
        const hexCodeLength = hexCode.length;
        if (hexCodeLength === 3) {
            rgb.push(parseInt(hexCode.charAt(0) + hexCode.charAt(0), 16), parseInt(hexCode.charAt(1) + hexCode.charAt(1), 16), parseInt(hexCode.charAt(2) + hexCode.charAt(2), 16));
        }
        else if (hexCodeLength === 4) {
            rgb.push(parseInt(hexCode.charAt(0) + hexCode.charAt(0), 16), parseInt(hexCode.charAt(1) + hexCode.charAt(1), 16), parseInt(hexCode.charAt(2) + hexCode.charAt(2), 16), parseInt(hexCode.charAt(3) + hexCode.charAt(3), 16));
        }
        else if (hexCodeLength === 6) {
            rgb.push(parseInt(hexCode.charAt(0) + hexCode.charAt(1), 16), parseInt(hexCode.charAt(2) + hexCode.charAt(3), 16), parseInt(hexCode.charAt(4) + hexCode.charAt(5), 16));
        }
        else if (hexCodeLength === 8) {
            rgb.push(parseInt(hexCode.charAt(0) + hexCode.charAt(1), 16), parseInt(hexCode.charAt(2) + hexCode.charAt(3), 16), parseInt(hexCode.charAt(4) + hexCode.charAt(5), 16), parseInt(hexCode.charAt(6) + hexCode.charAt(7), 16));
        }
        else {
            console_log.consoleLog("error", { hexToRGBError: "Invalid hex code" }, values$e.styleConsole);
        }
        return `rgb${![3, 6].includes(hexCodeLength) ? "a" : ""}(${rgb.join(",")})`;
    },
    HSLToRGB(HSL) {
        /* Convert hsl to rgb please */
        if (!["hsl", "hsla"].includes(HSL)) {
            return "rgb(255,0,0,1)";
        }
        /* Separate string by comas and eliminate rgb or rgba */
        const rgbSplited = HSL.split("(")[1]
            .split(")")[0]
            .split(",")
            .filter((r) => r !== "hsl" && r !== "hsla");
        const hDecimal = parseInt(rgbSplited[0]) / 100;
        const sDecimal = parseInt(rgbSplited[1]) / 100;
        const lDecimal = parseInt(rgbSplited[2]) / 100;
        if (parseInt(rgbSplited[1]) === 0) {
            return `rgb(${lDecimal},${lDecimal},${lDecimal})`;
        }
        let q = lDecimal < 0.5
            ? lDecimal * (1 + sDecimal)
            : lDecimal + sDecimal - lDecimal * sDecimal;
        let p = 2 * lDecimal - q;
        const r = this.HueToRGB(p, q, hDecimal + 1 / 3);
        const g = this.HueToRGB(p, q, hDecimal);
        const b = this.HueToRGB(p, q, hDecimal - 1 / 3);
        return `rgb${rgbSplited[3] && rgbSplited[3] !== "" ? "a" : ""}(${r},${g},${b}${rgbSplited[3] && rgbSplited[3] !== "" ? `,${rgbSplited[3]}` : ""})`;
    },
    HueToRGB(p, q, t) {
        if (t < 0)
            t += 1;
        if (t > 1)
            t -= 1;
        if (t < 1 / 6)
            return p + (q - p) * 6 * t;
        if (t < 1 / 2)
            return q;
        if (t < 2 / 3)
            return p + (q - p) * (2 / 3 - t) * 6;
        return p;
    },
    HWBToRGB(HWB) {
        const rgbSplited = HWB.split("(")[1]
            .split(")")[0]
            .split(",")
            .filter((r) => r !== "hsl" && r !== "hsla");
        let h = parseInt(rgbSplited[0]) / 360;
        let wh = parseInt(rgbSplited[1]) / 100;
        let bl = parseInt(rgbSplited[2]) / 100;
        let ratio = wh + bl;
        let i;
        let v;
        let f;
        let n;
        // wh + bl cant be > 1
        if (ratio > 1) {
            wh /= ratio;
            bl /= ratio;
        }
        i = Math.floor(6 * h);
        v = 1 - bl;
        f = 6 * h - i;
        if ((i & 0x01) !== 0) {
            f = 1 - f;
        }
        n = wh + f * (v - wh); // linear interpolation
        let r;
        let g;
        let b;
        switch (i) {
            default:
            case 6:
            case 0:
                r = v;
                g = n;
                b = wh;
                break;
            case 1:
                r = n;
                g = v;
                b = wh;
                break;
            case 2:
                r = wh;
                g = v;
                b = n;
                break;
            case 3:
                r = wh;
                g = n;
                b = v;
                break;
            case 4:
                r = n;
                g = wh;
                b = v;
                break;
            case 5:
                r = v;
                g = wh;
                b = n;
                break;
        }
        return `rgb${rgbSplited[3] && rgbSplited[3] !== "" ? "a" : ""}(${Math.round(r * 255)},${Math.round(g * 255)},${Math.round(b * 255)}${rgbSplited[3] && rgbSplited[3] !== "" ? `,${rgbSplited[3]}` : ""})`;
    },
    shadeTintColor(rgb, percent) {
        let R = rgb[0] === 0 && percent > 0
            ? 16
            : rgb[0] === 255 && percent < 0
                ? 239
                : rgb[0];
        let G = rgb[1] === 0 && percent > 0
            ? 16
            : rgb[1] === 255 && percent < 0
                ? 239
                : rgb[1];
        let B = rgb[2] === 0 && percent > 0
            ? 16
            : rgb[2] === 255 && percent < 0
                ? 239
                : rgb[2];
        R = parseInt(((R * (100 + percent)) / 100).toString());
        G = parseInt(((G * (100 + percent)) / 100).toString());
        B = parseInt(((B * (100 + percent)) / 100).toString());
        R = R > 255 ? 255 : R < 0 ? 0 : R;
        G = G > 255 ? 255 : G < 0 ? 0 : G;
        B = B > 255 ? 255 : B < 0 ? 0 : B;
        /* let RR = R.toString(16).length == 1 ? '0' + R.toString(16) : R.toString(16);
        let GG = G.toString(16).length == 1 ? '0' + G.toString(16) : G.toString(16);
        let BB = B.toString(16).length == 1 ? '0' + B.toString(16) : B.toString(16); */
        if (rgb[3]) {
            let A = rgb[3] ? (rgb[3] * 255).toString(16) : "FF";
            /* let AA =
              A.toString(16).length == 1 ? '0' + A.toString(16) : A.toString(16); */
            return [R, G, B, A];
        }
        else {
            return [R, G, B, 1];
        }
    },
};

/* Singletons */
const values$d = ValuesSingleton.getInstance();
const manage_sheet = {
    checkSheet() {
        let sheets = [...document.styleSheets];
        for (let nsheet of sheets) {
            if (nsheet.href?.includes("bef-styles")) {
                values$d.sheet = nsheet;
            }
        }
    },
    getSheet() {
        if (values$d.sheet) {
            console_log.consoleLog("info", { sheet: values$d.sheet }, values$d.styleConsole);
            return values$d.sheet;
        }
        else {
            return undefined;
        }
    },
};

/* Singletons */
const values$c = ValuesSingleton.getInstance();
const manage_CSSRules = {
    createCSSRules(rule) {
        try {
            console_log.consoleLog("info", { rule: rule }, values$c.styleConsole);
            if (rule && !rule.split("{")[0].includes("@media")) {
                let index;
                let originalRule = [...values$c.sheet.cssRules].some((cssRule, i) => {
                    if (cssRule.cssText.includes(rule.split("{")[0].replace("\n", "").replace(/\s+/g, " "))) {
                        index = i;
                        return true;
                    }
                    else {
                        return false;
                    }
                })
                    ? [...values$c.sheet.cssRules].find((i) => i.cssText
                        /* .includes(
                          rule.split('{')[0].replace('\n', '').replace(/\s+/g, ' ')
                        ) */
                        .split(" ")
                        .find((aC) => {
                        return (aC.replace(".", "") ===
                            rule.split("{")[0].replace("\n", "").replace(/\s+/g, " "));
                    })
                    /*
                  i.cssText.split(' ').find((aC: string) => {
                      return aC.replace('.', '') === bef;
                    })
                  */
                    )
                    : undefined;
                if (originalRule) {
                    values$c.sheet.deleteRule(index);
                }
                console_log.consoleLog("info", { rule: rule }, values$c.styleConsole);
                values$c.sheet.insertRule(rule, values$c.sheet.cssRules.length);
            }
            else {
                let originalMediaRules = false;
                let rulesParsed = rule
                    .replace(/{/g, values$c.separator)
                    .replace(/}/g, values$c.separator)
                    .split(values$c.separator)
                    .filter((r) => r !== "")
                    .map((r) => {
                    return r.replace(/\n/g, "").replace(/\s{2}/g, "");
                });
                let mediaRule = rulesParsed[0].includes("media")
                    ? rulesParsed[0]
                    : "";
                if (mediaRule !== "") {
                    if (mediaRule.endsWith(" ")) {
                        mediaRule = mediaRule.slice(0, -1);
                    }
                    rulesParsed.shift();
                    [...values$c.sheet.cssRules].forEach((css) => {
                        if (css.cssText.includes(mediaRule) && css.cssRules) {
                            originalMediaRules = true;
                            let i = 0;
                            while (i <= rulesParsed.length) {
                                let index = 0;
                                let posibleRule = [...css.cssRules].some((cssRule, ix) => {
                                    if (cssRule.cssText.includes(rulesParsed[i])) {
                                        index = ix;
                                        return true;
                                    }
                                    else {
                                        return false;
                                    }
                                })
                                    ? [...css.cssRules].find((i) => i.cssText.split(" ").find((aC) => {
                                        return aC.replace(".", "") === rulesParsed[i];
                                    }))
                                    : /* .includes(rulesParsed[i])) */
                                        /*
                                i.cssText.split(' ').find((aC: string) => {
                                    return aC.replace('.', '') === bef;
                                  })
                                */
                                        undefined;
                                if (!!posibleRule) {
                                    css.deleteRule(index);
                                }
                                let newRule = `${rulesParsed[i]}{${rulesParsed[i + 1]}}`;
                                console_log.consoleLog("info", { newRule: newRule }, values$c.styleConsole);
                                css.insertRule(newRule, css.cssRules.length);
                                i = i + 2;
                            }
                        }
                    });
                }
                if (originalMediaRules === false) {
                    console_log.consoleLog("info", { rule: rule }, values$c.styleConsole);
                    values$c.sheet.insertRule(rule, values$c.sheet.cssRules.length);
                }
            }
            console_log.consoleLog("info", { sheet: values$c.sheet }, values$c.styleConsole);
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$c.styleConsole);
        }
    },
};

/* Singletons */
const values$b = ValuesSingleton.getInstance();
const doCssCreate = {
    async start(updateBefs = null) {
        try {
            if (!values$b.sheet) {
                manage_sheet.checkSheet();
                if (!values$b.sheet) {
                    throw new Error('There is no bef-styles style sheet!');
                }
            }
            const startTimeCSSCreate = performance.now();
            let befs = [];
            if (!updateBefs) {
                let befElements = document.getElementsByClassName('bef');
                for (let befElement of befElements) {
                    befElement.classList.forEach((item) => {
                        let comb = Object.keys(values$b.combos).find((cs) => {
                            return item.includes(cs);
                        });
                        if (!!comb) {
                            if (values$b.combos[comb]) {
                                let vals = !!item.includes('VALS')
                                    ? item.split('VALS')[1].split('VL')
                                    : [];
                                values$b.combos[comb].forEach((c) => {
                                    let reg = new RegExp(/VAL[0-9]+(DEF[.]*DEF)?/, 'g');
                                    if (reg.test(c)) {
                                        let matches = c.match(reg);
                                        console_log.consoleLog('info', { matches: matches }, values$b.styleConsole);
                                        if (!!matches) {
                                            for (let match of matches) {
                                                let val = parseInt(match.split('VAL')[1].split('DEF')[0]);
                                                console_log.consoleLog('info', { val: val }, values$b.styleConsole);
                                                console_log.consoleLog('info', { match: match }, values$b.styleConsole);
                                                let pattern = `VAL${val}(DEF[.]*DEF)?`;
                                                let nreg = new RegExp(pattern, 'g');
                                                console_log.consoleLog('info', { nreg: nreg }, values$b.styleConsole);
                                                let def = match.split('DEF')[1];
                                                if (!!vals[val] &&
                                                    vals[val] !== '' &&
                                                    vals[val] !== 'undefined' &&
                                                    vals[val] !== 'DEF' &&
                                                    vals[val] !== 'null') {
                                                    console_log.consoleLog('info', { vals_val: vals[val] }, values$b.styleConsole);
                                                    if (/VAL[0-9]+/.test(vals[val])) {
                                                        let valval = vals[val].replace('VAL', '');
                                                        console_log.consoleLog('info', { valval: valval }, values$b.styleConsole);
                                                        c = c.replace(nreg, vals[parseInt(valval)]
                                                            ? vals[parseInt(valval)]
                                                            : def
                                                                ? def
                                                                : '');
                                                    }
                                                    else {
                                                        c = c.replace(nreg, vals[val]);
                                                        console_log.consoleLog('info', { c: c }, values$b.styleConsole);
                                                    }
                                                }
                                                else {
                                                    console_log.consoleLog('info', { def: def }, values$b.styleConsole);
                                                    c = c.replace(nreg, def ? def : '');
                                                }
                                            }
                                        }
                                    }
                                    if (c.startsWith('bef')) {
                                        let combosCreatedABBR = Object.keys(values$b.combosCreated);
                                        console_log.consoleLog('info', { combosCreatedABBR: combosCreatedABBR }, values$b.styleConsole);
                                        let alreadyABBRCombo = combosCreatedABBR.find((cs) => {
                                            return values$b.combosCreated[cs] === item;
                                        });
                                        console_log.consoleLog('info', { alreadyABBRCombo: alreadyABBRCombo }, values$b.styleConsole);
                                        let combosCreatedLenght = combosCreatedABBR.length;
                                        if (!alreadyABBRCombo) {
                                            values$b.combosCreated['■■■' + combosCreatedLenght] = item;
                                            console_log.consoleLog('info', {
                                                cStartsWithBef: values$b.combosCreated['■■■' + combosCreatedLenght],
                                            }, values$b.styleConsole);
                                        }
                                        console_log.consoleLog('info', { combosCreatedABBR: combosCreatedABBR }, values$b.styleConsole);
                                        let comboABBR = '■■■' +
                                            (combosCreatedLenght !== 0 ? combosCreatedLenght - 1 : 0);
                                        console_log.consoleLog('info', { comboABBR: comboABBR }, values$b.styleConsole);
                                        console_log.consoleLog('info', { c: c }, values$b.styleConsole);
                                        let pseudos = values$b.pseudos.filter((p) => c.split('-')[1].includes(p.mask));
                                        let firstPseudo = pseudos.sort((p1, p2) => {
                                            return c.indexOf(p1.mask) - c.indexOf(p2.mask);
                                        })[0] || -1;
                                        switch (true) {
                                            case pseudos.length > 0 &&
                                                !!(!c.includes('SEL') ||
                                                    c.indexOf('SEL') > c.indexOf(firstPseudo.mask)):
                                                console_log.consoleLog('info', { firstPseudo: firstPseudo }, values$b.styleConsole);
                                                c = c
                                                    .replace('SEL', '')
                                                    .replace(firstPseudo.mask, 'SEL__COM_' + comboABBR + firstPseudo.mask);
                                                console_log.consoleLog('info', { cIncludesPseudoAfter: c }, values$b.styleConsole);
                                                break;
                                            case !!c.includes('SEL'):
                                                c = c.replace('SEL', 'SEL__COM_' + comboABBR + '__');
                                                console_log.consoleLog('info', { cIncludesSELAfter: c }, values$b.styleConsole);
                                                break;
                                            default:
                                                console_log.consoleLog('info', { cDoesntIncludesSEL: c }, values$b.styleConsole);
                                                c = c.replace(c.split('-')[1], c.split('-')[1] + 'SEL__COM_' + comboABBR);
                                                console_log.consoleLog('info', { cDoesntIncludesSELAfter: c }, values$b.styleConsole);
                                                break;
                                        }
                                        /* if (!!c.includes('SEL')) {
                                          if (
                                            pseudos.length > 0 &&
                                            !!(c.indexOf('SEL') > c.indexOf(firstPseudo.mask))
                                          ) {
                                            c = c
                                              .replace('SEL', '')
                                              .replace(
                                                firstPseudo.mask,
                                                'SEL__COM_' + comboABBR + firstPseudo.mask
                                              );
                                          } else {
                                            c = c.replace('SEL', 'SEL__COM_' + comboABBR + '__');
                                          }
                                        } else {
                                          if (pseudos.length > 0) {
                                            let firstPseudo = pseudos.sort((p1, p2) => {
                                              return c.indexOf(p1.mask) - c.indexOf(p2.mask);
                                            })[0];
                                            c = c.replace(
                                              firstPseudo.mask,
                                              'SEL__COM_' + comboABBR + firstPseudo.mask
                                            );
                                          } else {
                                            c = c.replace(
                                              c.split('-')[1],
                                              c.split('-')[1] + 'SEL__COM_' + comboABBR
                                            );
                                          }
                                        } */
                                    }
                                    else {
                                        console_log.consoleLog('info', { cDoesntStartsWithBef: c }, values$b.styleConsole);
                                        befElement.classList.add(c);
                                    }
                                    if (!befs.includes(c)) {
                                        befs.push(c);
                                    }
                                });
                            }
                        }
                        else if (!befs.includes(item) &&
                            item !== 'bef' &&
                            (item.includes('bef') ||
                                Object.keys(values$b.abreviationsClasses).find((aC) => item.includes(aC)))) {
                            befs.push(item);
                        }
                    });
                }
            }
            else {
                befs = updateBefs;
            }
            console_log.consoleLog('info', { befs: befs }, values$b.styleConsole);
            let befsStringed = '';
            let bpsStringed = values$b.bps.map((b) => b);
            for (let bef of befs) {
                if (!updateBefs) {
                    if (values$b.alreadyCreatedClasses.find((aC) => {
                        return aC === bef;
                    })) {
                        continue;
                    }
                    if ([...values$b.sheet.cssRules].find((i) => i.cssText.split(' ').find((aC) => {
                        return aC.replace('.', '') === bef;
                    }))) {
                        continue;
                    }
                }
                if (!values$b.alreadyCreatedClasses.find((aC) => {
                    return aC === bef;
                })) {
                    values$b.alreadyCreatedClasses.push(bef);
                }
                let befStringed = '.' + bef;
                if (!bef.includes('bef')) {
                    let abbrClss = Object.keys(values$b.abreviationsClasses).find((aC) => bef.includes(aC));
                    if (!!abbrClss) {
                        bef = bef.replace(abbrClss, values$b.abreviationsClasses[abbrClss]);
                    }
                }
                let befSplited = bef.split('-');
                /* if (befSplited[1].includes('SLASH')) {
                  debugger;
                } */
                console_log.consoleLog('info', { befSplited1: befSplited[1] }, values$b.styleConsole);
                let befSRP = this.removePseudos(befSplited[1])
                    .replace(/SEL/g, values$b.separator)
                    .split(`${values$b.separator}`);
                console_log.consoleLog('info', { befSRP: befSRP }, values$b.styleConsole);
                let selector = befSRP[0];
                let specify = abrevviation_traductors.abreviationTraductor(befSRP
                    .map((bs, i) => {
                    if (i !== 0) {
                        return bs;
                    }
                    else {
                        return '';
                    }
                })
                    .join(''));
                if (!!specify) {
                    let alreadyABBRCombo = Object.keys(values$b.combosCreated).find((cs) => specify.includes(cs));
                    if (!!alreadyABBRCombo) {
                        console_log.consoleLog('info', { OPalreadyABBRCombo: alreadyABBRCombo }, values$b.styleConsole);
                        specify = specify.replace(alreadyABBRCombo, values$b.combosCreated[alreadyABBRCombo]);
                        bef = bef.replace(alreadyABBRCombo, values$b.combosCreated[alreadyABBRCombo]);
                    }
                }
                let hasBP = false;
                let value = '';
                let secondValue = '';
                if (values$b.bps.find((b) => befSplited[2] === b.bp)) {
                    hasBP = true;
                    value = befSplited[3];
                    secondValue = !!befSplited[4] ? befSplited[4] : '';
                }
                else if (befSplited[2]) {
                    value = befSplited[2];
                    secondValue = !!befSplited[3] ? befSplited[3] : '';
                }
                /* befSplited[1] = befSplited[1]
                  .replace(/COM/g, ' , ')
                  .replace(/__/g, ' ')
                  .replace(/_/g, '.'); */
                value = abrevviation_traductors.abreviationTraductor(!!values$b.abreviationsValues[value]
                    ? values$b.abreviationsValues[value]
                    : value);
                secondValue = abrevviation_traductors.abreviationTraductor(!!values$b.abreviationsValues[secondValue]
                    ? values$b.abreviationsValues[secondValue]
                    : secondValue);
                let vals = {
                    value: value,
                    secondValue: secondValue,
                };
                if (!selector.includes('content')) {
                    Object.keys(vals).forEach((v) => {
                        let hasOPA = vals[v].includes('OPA');
                        if (!!hasOPA) {
                            const reg = new RegExp(/(?:([A-z0-9#]*)|(?:(rgb)|(hsl)|(hwb))a?\([0-9\.\,\s%]*\))\s?OPA\s?0\.[0-9]*/gi);
                            const OPAS = vals[v].match(reg);
                            for (let OPA of OPAS) {
                                const color = OPA.split('OPA')[0];
                                const OPAValue = OPA.split('OPA')[1];
                                let realColor = `${color_transform
                                    .colorToRGB(!!values$b.colors[color.toString().replace(/\s/g, '')]
                                    ? values$b.colors[color.toString().replace(/\s/g, '')]
                                    : color)
                                    .toString()}`;
                                vals[v] = !!OPAValue
                                    ? vals[v]
                                        .replace(color, `rgba(${realColor},${OPAValue})`)
                                        .replace('OPA' + OPAValue, '')
                                    : vals[v];
                            }
                        }
                        let colors = Object.keys(values$b.colors)
                            .sort((c1, c2) => {
                            return c2.length - c1.length;
                        })
                            .map((c) => `(${c})`)
                            .join('|');
                        let reg = new RegExp('(?:' + colors + ')', 'gi');
                        let matches = vals[v].match(reg);
                        if (!!matches) {
                            for (let match of matches) {
                                let realColor = values$b.colors[match.replace(/\s/g, '')];
                                if (!!realColor) {
                                    vals[v] = vals[v].replace(match, `rgba(${color_transform.colorToRGB(realColor)})`);
                                }
                            }
                        }
                    });
                }
                value = vals.value;
                secondValue = vals.secondValue;
                console_log.consoleLog('info', { value: value, secondValue: secondValue }, values$b.styleConsole);
                /* MatchForColors */
                /* MatchForColorsEnd */
                switch (true) {
                    case !!values$b.cssNamesParsed[selector.toString()]:
                        if (typeof values$b.cssNamesParsed[selector.toString()] === 'string') {
                            befStringed += `${specify}{${values$b.cssNamesParsed[selector.toString()]}:${value};}`;
                        }
                        else {
                            befStringed += `${specify}{${values$b.cssNamesParsed[selector.toString()][0]}:${value};${values$b.cssNamesParsed[selector.toString()][1]}:${value};}`;
                        }
                        break;
                    case befSplited[1].startsWith('link'):
                        befStringed += ` a${specify}{color:${value};}`;
                        break;
                    case befSplited[1] === 'btn':
                        befStringed += `{
                    background-color:${value};
                    border-color:${value};}
                  ${values$b.separator}.${bef}:hover{background-color:rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), -15)
                            .toString()});border-color:rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), -20)
                            .toString()});}
                  ${values$b.separator}.btn-check:focus + .${bef}, .${bef}:focus{background-color:rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), -15)
                            .toString()});border-color:rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), -20)
                            .toString()});}
                  ${values$b.separator}.btn-check:checked + .${bef}, .btn-check:active + .${bef}, .${bef}:active, .${bef}.active, .show > .${bef}.dropdown-toggle{background-color:${color_transform.shadeTintColor(color_transform.colorToRGB(value), -20)};border-color:rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), -25)
                            .toString()});box-shadow: 0 0 0 0.25rem
                  rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), 3)
                            .toString()}, 0.5)
                  ;}
                  ${values$b.separator}.btn-check:checked + .btn-check:focus, .btn-check:active + .${bef}:focus, .${bef}:active:focus, .${bef}.active:focus, .show > .${bef}.dropdown-toggle:focus{box-shadow: 0 0 0 0.25rem
                    rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), 3)
                            .toString()}, 0.5)
                  ;}`;
                        break;
                    case befSplited[1] === 'btnOutline':
                        befStringed += `{
                    color:${value};
                    background-color:${secondValue ? secondValue : 'default'};
                      border-color:${value};}
                    ${values$b.separator}.${bef}:hover{
                      background-color:${value};
                      color:${secondValue ? secondValue : 'default'};
                      border-color:rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), -20)
                            .toString()});}
                    ${values$b.separator}.btn-check:focus + .${bef}, .${bef}:focus{
                      border-color:rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), -20)
                            .toString()});}
                    ${values$b.separator}.btn-check:checked + .${bef}, .btn-check:active + .${bef}, .${bef}:active, .${bef}.active, .show > .${bef}.dropdown-toggle{
                      border-color:rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), -25)
                            .toString()});
                    box-shadow: 0 0 0 0.25rem
                    rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), 3)
                            .toString()}, 0.5)
                    ;}
                    ${values$b.separator}.btn-check:checked + .btn-check:focus, .btn-check:active + .${bef}:focus, .${bef}:active:focus, .${bef}.active:focus, .show > .${bef}.dropdown-toggle:focus{
                      box-shadow: 0 0 0 0.25rem
                      rgba(${color_transform
                            .shadeTintColor(color_transform.colorToRGB(value), 3)
                            .toString()}, 0.5)
                    ;}`;
                        break;
                    default:
                        befStringed += `${specify}{${css_camel.camelToCSSValid(selector)}:${value};}`;
                        break;
                }
                if (!!values$b.importantActive) {
                    for (let cssProperty of befStringed.split(';')) {
                        if (!cssProperty.includes('!important') && cssProperty.length > 5) {
                            befStringed = befStringed.replace(cssProperty, cssProperty + ' !important');
                        }
                    }
                }
                if (befStringed.includes('{') && befStringed.includes('}')) {
                    if (hasBP === true) {
                        befStringed = befStringed.replace(new RegExp(values$b.separator, 'g'), '');
                        bpsStringed = bpsStringed.map((b) => {
                            if (befSplited[2] === b.bp) {
                                b.bef += befStringed;
                            }
                            return b;
                        });
                    }
                    else {
                        befsStringed += befStringed + values$b.separator;
                    }
                }
            }
            if (befsStringed !== '') {
                console_log.consoleLog('info', { befsStringed: befsStringed }, values$b.styleConsole);
                for (let bef of befsStringed.split(values$b.separator)) {
                    if (bef !== '') {
                        manage_CSSRules.createCSSRules(bef);
                    }
                }
            }
            bpsStringed = bpsStringed
                .sort((b1, b2) => {
                return (parseInt(b1.value.replace('px', '')) -
                    parseInt(b2.value.replace('px', '')));
            })
                .reverse();
            bpsStringed.forEach((b, i) => {
                if (b.bef !== '') {
                    console_log.consoleLog('info', { bp: b.bp, value: b.value, bef: b.bef }, values$b.styleConsole);
                    manage_CSSRules.createCSSRules(`@media only screen and (min-width: ${b.value}) { html body ${b.bef}}`);
                    /*
                    ${
                        bpsStringed.length > 1 && i !== 0
                          ? `and (max-width: ${bpsStringed[i - 1].value})`
                          : ''
                      }
                    */
                    manage_CSSRules.createCSSRules(`@media only screen and (min-width: ${b.value}) ${bpsStringed.length > 1 && i !== 0
                        ? `and (max-width: ${bpsStringed[i - 1].value})`
                        : ''} { #bef-bp ${b.bef}}`);
                    b.bef = '';
                }
            });
            const endTimeCSSCreate = performance.now();
            console_log.consoleLog('info', `Call to cssCreate() took ${endTimeCSSCreate - startTimeCSSCreate} milliseconds`, values$b.styleConsole);
            let befTimer = document.getElementById('befTimer');
            if (befTimer) {
                befTimer.innerHTML = `
            <p>
            Call to cssCreate() took ${endTimeCSSCreate - startTimeCSSCreate} milliseconds
            </p>
            `;
            }
        }
        catch (err) {
            console_log.consoleLog('error', { err: err }, values$b.styleConsole);
        }
    },
    /* private */ removePseudos(thing, remove = false) {
        console_log.consoleLog('info', { thing_beforeRemovePseudos: thing });
        let pseudoFiltereds = values$b.pseudos.filter((pseudo) => {
            return thing.includes(pseudo.mask);
        });
        pseudoFiltereds.forEach((pse) => {
            let regMask = new RegExp(':*' + pse.mask, 'gi');
            switch (true) {
                case values$b.pseudosHasSDED.includes(pse.mask):
                    regMask = new RegExp(':*' + pse.mask + '\\' + '(', 'gi');
                    break;
                case ['Right', 'Left'].includes(pse.mask):
                    regMask = new RegExp('page' + pse.mask, 'gi');
                    break;
                default:
                    break;
            }
            thing = thing
                .replace('SD', '(')
                .replace('ED', ')')
                .replace(regMask, !remove
                ? values$b.pseudosHasSDED.includes(pse.mask)
                    ? pse.real + '('
                    : ['Right', 'Left'].includes(pse.mask)
                        ? 'page' + pse.real
                        : pse.real
                : '');
        });
        console_log.consoleLog('info', { thing_afterRemovePseudos: thing });
        return thing;
    },
};

/* Singletons */
const values$a = ValuesSingleton.getInstance();
const timeManagerCssCreate = {
    delayedCssCreate(updateBefs = null, primordial = false) {
        if (Date.now() - values$a.lastCSSCreate >= values$a.timeBetweenReCreate ||
            primordial === true ||
            values$a.timesCSSCreated === 0) {
            values$a.timesCSSCreated++;
            doCssCreate.start(updateBefs);
            values$a.lastCSSCreate = Date.now();
            console_log.consoleParser({
                thing: { timesCSSCreated: values$a.timesCSSCreated },
            });
        }
        else {
            if (Date.now() - values$a.timeBetweenReCreate <
                values$a.lastTimeAsked2Create) {
                this.handleDelayedCssCreate(updateBefs, primordial);
            }
        }
    },
    handleDelayedCssCreate(updateBefs = null, primordial = false) {
        setTimeout(() => {
            this.delayedCssCreate(updateBefs, primordial);
        }, values$a.timeBetweenReCreate);
    },
};

/* Singletons */
const values$9 = ValuesSingleton.getInstance();
const doUseTimer = (updateBefs = null, primordial = false) => {
    values$9.lastTimeAsked2Create = Date.now();
    timeManagerCssCreate.delayedCssCreate(updateBefs, primordial);
};

/* Singletons */
const values$8 = ValuesSingleton.getInstance();
const cssCreate = {
    cssCreate(updateBefs = null, primordial = false) {
        try {
            if (!values$8.sheet) {
                manage_sheet.checkSheet();
                if (!values$8.sheet) {
                    throw new Error(`There is no bef-styles style sheet!`);
                }
            }
            if (!!values$8.useTimer) {
                doUseTimer(updateBefs, primordial);
            }
            else {
                doCssCreate.start(updateBefs);
            }
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$8.styleConsole);
        }
    },
};

const values$7 = ValuesSingleton.getInstance();
const debugg_options = {
    changeDebugOption(option) {
        values$7.isDebug = option || !values$7.isDebug;
    },
    changeUseTimerOption(option) {
        values$7.useTimer = option || !values$7.useTimer;
    },
    setTimeBetweenReCreate(time) {
        values$7.timeBetweenReCreate = time;
    },
};

/* Singletons */
const values$6 = ValuesSingleton.getInstance();
const manage_abreviations = {
    pushAbreviationsValues(abreviationsValues) {
        try {
            let prevIgnoredAbreviationsValues = [];
            Object.keys(abreviationsValues).forEach((key) => {
                values$6.abreviationsValues[key] = abreviationsValues[key];
                prevIgnoredAbreviationsValues = values$6.alreadyCreatedClasses.filter((aC) => {
                    return aC.includes(key);
                });
            });
            if (prevIgnoredAbreviationsValues.length > 0) {
                cssCreate.cssCreate(prevIgnoredAbreviationsValues);
            }
        }
        catch (err) {
            console_log.consoleLog('error', { err: err }, values$6.styleConsole);
        }
    },
    pushAbreviationsClasses(abreviationsClasses) {
        let prevIgnoredAbreviationsValues = [];
        try {
            Object.keys(abreviationsClasses).forEach((key) => {
                values$6.abreviationsClasses[key] = abreviationsClasses[key];
                prevIgnoredAbreviationsValues = values$6.alreadyCreatedClasses.filter((aC) => {
                    return aC.includes(key);
                });
            });
            if (prevIgnoredAbreviationsValues.length > 0) {
                cssCreate.cssCreate(prevIgnoredAbreviationsValues);
            }
            else {
                cssCreate.cssCreate();
            }
        }
        catch (err) {
            console_log.consoleLog('error', { err: err }, values$6.styleConsole);
        }
    },
    getAbreviationsClasses() {
        console_log.consoleLog('info', { abreviationsClasses: values$6.abreviationsClasses }, values$6.styleConsole);
        return values$6.abreviationsClasses;
    },
    getAbreviationsValues() {
        console_log.consoleLog('info', { abreviationsValues: values$6.abreviationsValues }, values$6.styleConsole);
        return values$6.abreviationsValues;
    },
    updateAbreviationsClass(abreviationsClass, value) {
        try {
            if (values$6.abreviationsClasses[abreviationsClass.toString()]) {
                values$6.abreviationsClasses[abreviationsClass] = value;
                let classesToUpdate = [];
                for (let createdClass of values$6.alreadyCreatedClasses) {
                    if (createdClass.includes(abreviationsClass)) {
                        classesToUpdate.push(createdClass);
                    }
                }
                if (classesToUpdate.length > 0) {
                    cssCreate.cssCreate(classesToUpdate);
                }
            }
            else {
                throw new Error(`There is no abreviationsClass named ${abreviationsClass}.`);
            }
        }
        catch (err) {
            console_log.consoleLog('error', { err: err }, values$6.styleConsole);
        }
    },
    updateAbreviationsValue(abreviationsValue, value) {
        try {
            if (values$6.abreviationsValues[abreviationsValue.toString()]) {
                values$6.abreviationsValues[abreviationsValue] = value;
                let classesToUpdate = [];
                for (let createdClass of values$6.alreadyCreatedClasses) {
                    if (createdClass.includes(abreviationsValue)) {
                        classesToUpdate.push(createdClass);
                    }
                }
                if (classesToUpdate.length > 0) {
                    cssCreate.cssCreate(classesToUpdate);
                }
            }
            else {
                throw new Error(`There is no abreviationsValue named ${abreviationsValue}.`);
            }
        }
        catch (err) {
            console_log.consoleLog('error', { err: err }, values$6.styleConsole);
        }
    },
};

/* Singletons */
const values$5 = ValuesSingleton.getInstance();
const manage_bps = {
    pushBPS(bps) {
        try {
            for (let nb of bps) {
                let bp = values$5.bps.find((b) => b.bp === nb.bp);
                if (bp) {
                    bp.value = nb.value;
                    bp.bef = "";
                }
                else {
                    values$5.bps.push({
                        bp: nb.bp,
                        value: nb.value,
                        bef: "",
                    });
                }
            }
            cssCreate.cssCreate();
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$5.styleConsole);
        }
    },
    getBPS() {
        console_log.consoleLog("info", { bps: values$5.bps }, values$5.styleConsole);
        return values$5.bps;
    },
};

/* Singletons */
const values$4 = ValuesSingleton.getInstance();
const manage_classes = {
    getAlreadyCreatedClasses() {
        console_log.consoleLog("info", { alreadyCreatedClasses: values$4.alreadyCreatedClasses }, values$4.styleConsole);
        return values$4.alreadyCreatedClasses;
    },
    updateClasses(classesToUpdate) {
        cssCreate.cssCreate(classesToUpdate);
    },
};

/* Singletons */
const values$3 = ValuesSingleton.getInstance();
const manage_colors = {
    pushColors(newColors) {
        try {
            Object.keys(newColors).forEach((key) => {
                values$3.colors[key] = newColors[key].replace("!important" || "!default" || /\s+/g, "");
            });
            for (let color in newColors) {
                let classesToUpdate = [];
                for (let createdClass of values$3.alreadyCreatedClasses) {
                    if (createdClass.includes(color)) {
                        classesToUpdate.push(createdClass);
                    }
                }
                if (classesToUpdate.length > 0) {
                    cssCreate.cssCreate(classesToUpdate);
                }
            }
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$3.styleConsole);
        }
    },
    getColors() {
        console_log.consoleLog("info", { colors: values$3.colors }, values$3.styleConsole);
        return values$3.colors;
    },
    getColorsNames() {
        const colorsNames = [];
        Object.keys(values$3.colors).forEach((key) => {
            colorsNames.push(key);
        });
        return colorsNames;
    },
    getColorValue(color) {
        console_log.consoleLog("info", { color: color, colorValue: values$3.colors[color] }, values$3.styleConsole);
        return values$3.colors[color];
    },
    updateColor(color, value) {
        try {
            if (values$3.colors[color.toString()]) {
                values$3.colors[color] = value.replace("!important" || "!default" || /\s+/g, "");
                let classesToUpdate = [];
                for (let createdClass of values$3.alreadyCreatedClasses) {
                    if (createdClass.includes(color)) {
                        classesToUpdate.push(createdClass);
                    }
                }
                if (classesToUpdate.length > 0) {
                    cssCreate.cssCreate(classesToUpdate);
                }
            }
            else {
                throw new Error(`There is no color named ${color}.`);
            }
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$3.styleConsole);
        }
    },
    deleteColor(color) {
        try {
            if (!!values$3.colors[color.toString()]) {
                delete values$3.colors[color];
            }
            else {
                throw new Error(`There is no color named ${color}.`);
            }
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$3.styleConsole);
        }
    },
    clearAllColors() {
        values$3.colors = {};
        console_log.consoleLog("info", { colors: values$3.colors }, values$3.styleConsole);
    },
};

/* Singletons */
const values$2 = ValuesSingleton.getInstance();
const manage_combos = {
    pushCombos(combos) {
        try {
            let prevIgnoredCombosValues = [];
            Object.keys(combos).forEach((key) => {
                values$2.combos[key] =
                    typeof combos[key] === "string"
                        ? combos[key].split(" ")
                        : combos[key]
                            .map((c) => {
                            return c.split(" ").flat();
                        })
                            .flat();
                prevIgnoredCombosValues = values$2.alreadyCreatedClasses.filter((aC) => {
                    return aC.includes(key);
                });
            });
            if (prevIgnoredCombosValues.length > 0) {
                cssCreate.cssCreate(prevIgnoredCombosValues);
            }
            else {
                cssCreate.cssCreate();
            }
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$2.styleConsole);
        }
    },
    getCombos() {
        console_log.consoleLog("info", { combos: values$2.combos }, values$2.styleConsole);
        return values$2.combos;
    },
    updateCombo(combo, newValues) {
        try {
            if (values$2.combos[combo.toString()]) {
                values$2.combos[combo] = newValues;
                let classes2Delete = [];
                for (let createdClass of values$2.alreadyCreatedClasses) {
                    if (createdClass.includes(combo)) {
                        classes2Delete.push(createdClass);
                    }
                }
                if (classes2Delete.length > 0) {
                    for (let class2Delete of classes2Delete) {
                        values$2.sheet.deleteRule([...values$2.sheet.cssRules].findIndex((cssRule) => {
                            return cssRule.cssText.includes(class2Delete);
                        }));
                        values$2.alreadyCreatedClasses = values$2.alreadyCreatedClasses.filter((aC) => {
                            return aC !== class2Delete;
                        });
                    }
                    cssCreate.cssCreate();
                }
            }
            else {
                throw new Error(`There is no combo named ${combo}.`);
            }
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$2.styleConsole);
        }
    },
};

/* Singletons */
const values$1 = ValuesSingleton.getInstance();
const manage_CSSNamesParsed = {
    pushCssNamesParsed(cssNamesParsed) {
        try {
            Object.keys(cssNamesParsed).forEach((key) => {
                values$1.cssNamesParsed[key] = cssNamesParsed[key];
            });
            cssCreate.cssCreate();
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$1.styleConsole);
        }
    },
    getCssNamesParsed() {
        console_log.consoleLog("info", { cssNamesParsed: values$1.cssNamesParsed }, values$1.styleConsole);
        return values$1.cssNamesParsed;
    },
    updateCssNamesParsed(cssNameParsed, value) {
        try {
            if (values$1.cssNamesParsed[cssNameParsed.toString()]) {
                values$1.cssNamesParsed[cssNameParsed] = value;
                let classesToUpdate = [];
                for (let createdClass of values$1.alreadyCreatedClasses) {
                    if (createdClass.includes(cssNameParsed)) {
                        classesToUpdate.push(createdClass);
                    }
                }
                if (classesToUpdate.length > 0) {
                    cssCreate.cssCreate(classesToUpdate);
                }
            }
            else {
                throw new Error(`There is no cssNameParsed named ${cssNameParsed}.`);
            }
        }
        catch (err) {
            console_log.consoleLog("error", { err: err }, values$1.styleConsole);
        }
    },
};

const values = ValuesSingleton.getInstance();
const utility_configurations = {
    changeImportantActive(option) {
        values.importantActive = option || !values.importantActive;
        cssCreate.cssCreate();
    },
};

class NgxBootstrapExpandedFeaturesService {
    constructor() {
        this.values = ValuesSingleton.getInstance();
        this.colors = this.values.colors;
        this.abreviationsClasses = this.values.abreviationsClasses;
        this.abreviationsValues = this.values.abreviationsValues;
        this.combos = this.values.combos;
        this.combosCreated = this.values.combosCreated;
        this.cssNamesParsed = this.values.cssNamesParsed;
        this.alreadyCreatedClasses = this.values.alreadyCreatedClasses;
        this.sheet = this.values.sheet;
        this.isDebug = this.values.isDebug;
        this.bps = this.values.bps;
        this.separator = this.values.separator;
        this.styleConsole = this.values.styleConsole;
        this.pseudoClasses = this.values.pseudoClasses;
        this.pseudosHasSDED = this.values.pseudosHasSDED;
        this.pseudoElements = this.values.pseudoElements;
        this.pseudos = this.values.pseudos;
        this.importantActive = this.values.importantActive;
        this.abreviationTraductors = this.values.abreviationTraductors;
        this.lastCSSCreate = this.values.lastCSSCreate;
        this.lastTimeAsked2Create = this.values.lastTimeAsked2Create;
        this.timesCSSCreated = this.values.timesCSSCreated;
        this.timeBetweenReCreate = this.values.timeBetweenReCreate;
        this.useTimer = this.values.useTimer;
        this.cssCreate = (updateBefs = null, primordial = false) => cssCreate.cssCreate(updateBefs, primordial);
        this.createCSSRules = (rule) => manage_CSSRules.createCSSRules(rule);
        this.colorToRGB = (color) => color_transform.colorToRGB(color);
        this.RGBToRGBA = (rgb, alpha) => color_transform.RGBToRGBA(rgb, alpha);
        this.parseRGB = (rgba) => color_transform.parseRGB(rgba);
        this.HexToRGB = (Hex) => color_transform.HexToRGB(Hex);
        this.HSLToRGB = (HSL) => color_transform.HSLToRGB(HSL);
        this.HWBToRGB = (HWB) => color_transform.HWBToRGB(HWB);
        this.shadeTintColor = (rgb, percent) => color_transform.shadeTintColor(rgb, percent);
        this.cssValidToCamel = (st) => css_camel.cssValidToCamel(st);
        this.camelToCSSValid = (st) => css_camel.camelToCSSValid(st);
        /* CRUD */
        this.pushCssNamesParsed = (cssNamesParsed) => manage_CSSNamesParsed.pushCssNamesParsed(cssNamesParsed);
        this.pushBPS = (bps) => manage_bps.pushBPS(bps);
        this.pushColors = (newColors) => manage_colors.pushColors(newColors);
        this.pushAbreviationsValues = (abreviationsValues) => manage_abreviations.pushAbreviationsValues(abreviationsValues);
        this.pushAbreviationsClasses = (abreviationsClasses) => manage_abreviations.pushAbreviationsClasses(abreviationsClasses);
        this.pushCombos = (combos) => manage_combos.pushCombos(combos);
        /* Getters */
        this.getColors = () => manage_colors.getColors();
        this.getBPS = () => manage_bps.getBPS();
        this.getAbreviationsValues = () => manage_abreviations.getAbreviationsValues();
        this.getAbreviationsClasses = () => manage_abreviations.getAbreviationsClasses();
        this.getCombos = () => manage_combos.getCombos();
        this.getCssNamesParsed = () => manage_CSSNamesParsed.getCssNamesParsed();
        this.getColorsNames = () => manage_colors.getColorsNames();
        this.getColorValue = (color) => manage_colors.getColorValue(color);
        this.getAlreadyCreatedClasses = () => manage_classes.getAlreadyCreatedClasses();
        this.getSheet = () => manage_sheet.getSheet();
        /* Update */
        this.updateColor = (color, value) => manage_colors.updateColor(color, value);
        this.updateAbreviationsClass = (abreviationsClass, value) => manage_abreviations.updateAbreviationsClass(abreviationsClass, value);
        this.updateAbreviationsValue = (abreviationsValue, value) => manage_abreviations.updateAbreviationsValue(abreviationsValue, value);
        this.updateCombo = (combo, values) => manage_combos.updateCombo(combo, values);
        this.updateCssNamesParsed = (cssNameParsed, value) => manage_CSSNamesParsed.updateCssNamesParsed(cssNameParsed, value);
        this.updateClasses = (classesToUpdate) => manage_classes.updateClasses(classesToUpdate);
        /* Delete */
        this.deleteColor = (color) => manage_colors.deleteColor(color);
        this.clearAllColors = () => manage_colors.clearAllColors();
        /* Utility */
        this.changeImportantActive = (active) => utility_configurations.changeImportantActive(active);
        this.changeDebugOption = (active) => debugg_options.changeDebugOption(active);
        this.changeUseTimerOption = (active) => debugg_options.changeUseTimerOption(active);
        this.setTimeBetweenReCreate = (time) => debugg_options.setTimeBetweenReCreate(time);
        this.unbefysize = (value) => abrevviation_traductors.unbefysize(value);
        this.befysize = (value) => abrevviation_traductors.befysize(value);
        this.consoleLog = (type = 'log', thing, style = this.values.styleConsole, line = null, stoper = !this.values.isDebug) => console_log.consoleLog(type, thing, style, line, stoper);
        this.consoleParser = (config) => console_log.consoleParser(config);
        manage_sheet.checkSheet();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.2", ngImport: i0, type: NgxBootstrapExpandedFeaturesService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.2", ngImport: i0, type: NgxBootstrapExpandedFeaturesService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.2", ngImport: i0, type: NgxBootstrapExpandedFeaturesService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

class BefInitDirective {
    constructor() {
        this.initEvent = new EventEmitter();
    }
    ngOnInit() {
        if (this.exist) {
            setTimeout(() => this.initEvent.emit(), 10);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.2", ngImport: i0, type: BefInitDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.2", type: BefInitDirective, selector: "[befInit]", inputs: { exist: "exist" }, outputs: { initEvent: "befInit" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.2", ngImport: i0, type: BefInitDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[befInit]',
                }]
        }], propDecorators: { exist: [{
                type: Input
            }], initEvent: [{
                type: Output,
                args: ['befInit']
            }] } });

/*
 * Public API Surface of ngx-bootstrap-expanded-features
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BefInitDirective, NgxBootstrapExpandedFeaturesService };
//# sourceMappingURL=ngx-bootstrap-expanded-features.mjs.map
